diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
index 4289fa091..45c1bdaea 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
@@ -25,7 +25,8 @@ import java.util.Objects;
 
 public class BlockLogicBed
     extends BlockLogic
-    implements ISupportable {
+    implements ISupportable, BlockLogic.MatcherDataEquivalency.Masked
+{
 
     public BlockLogicBed(final @NotNull Block<?> block) {
         super(block, Materials.WOOD);
@@ -33,8 +34,8 @@ public class BlockLogicBed
     }
 
     @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        return data & ~(DIRECTION.mask | IS_OCCUPIED.mask);
+    public int getMatcherDataEquivalencyMask() {
+        return ~(DIRECTION.mask | IS_OCCUPIED.mask);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
index 63d149c3f..ae0603624 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicButton.java
@@ -26,7 +26,7 @@ import java.util.Random;
 
 public class BlockLogicButton
     extends BlockLogic
-    implements IPaintable, ISupportable {
+    implements IPaintable, ISupportable, BlockLogic.MatcherDataEquivalency.Masked  {
     public static final int MASK_POWERED = 0b0000_1000;
     public static final int MASK_DIRECTION = 0b0000_0111;
     public static final int SIDE_WEST = 1;
@@ -42,8 +42,8 @@ public class BlockLogicButton
     }
 
     @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        return data & MASK_POWERED;
+    public int getMatcherDataEquivalencyMask() {
+        return ~MASK_DIRECTION;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
index 0c8daee2f..cbd627b8b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
@@ -144,9 +144,4 @@ public class BlockLogicCactus
         }
         return true;
     }
-
-    @Override
-    protected int getMatcherEquivalenceData(int data) {
-        return 0;
-    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
index 8c9255995..a2205ce9b 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
@@ -19,18 +19,20 @@ import java.util.Objects;
 
 public class BlockLogicChest
     extends BlockLogic
-    implements IPaintable {
+    implements IPaintable, BlockLogic.MatcherDataEquivalency {
     public BlockLogicChest(final @NotNull Block<?> block, final @NotNull Material material) {
         super(block, material);
         block.withEntity(TileEntityChest::new);
     }
 
     @Override
-    protected int getMatcherEquivalenceData(int data) {
-        data &= ~directionBits;
+    public boolean isEquivalentDataForMatcherImpl(int thisData, int thatData) {
+        final int mask1 = ~(directionBits | typeBits);
+        if ((thisData & mask1) != (thatData & mask1)) return false;
+
         assert Type.SINGLE.ordinal() == 0;
-        if ((data & typeBits) != 0) data |= typeBits;
-        return data;
+        // would be easier if we use 0b01 and 0b11 instead of 0b01 and 0b10
+        return ((thisData & typeBits) == 0) == ((thatData & typeBits) == 0);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicConduit.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicConduit.java
index cb86b616d..ba134cfca 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicConduit.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicConduit.java
@@ -1,11 +1,13 @@
 package net.minecraft.core.block;
 
 import net.minecraft.core.block.material.Material;
+import net.minecraft.core.current.util.BlockState;
+import net.minecraft.core.block.piston.BlockLogicPistonBase;
+import net.minecraft.core.block.piston.BlockLogicPistonHead;
+import net.minecraft.core.block.piston.PistonCommon;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.Mob;
 import net.minecraft.core.entity.player.Player;
-import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.item.Items;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
@@ -17,12 +19,13 @@ import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-import java.lang.reflect.Array;
 import java.util.ArrayList;
 import java.util.List;
 import java.util.Random;
 
-public class BlockLogicConduit extends BlockLogic {
+public class BlockLogicConduit extends BlockLogic
+    implements BlockLogic.MatcherDataEquivalency
+{
 
     public static final Side[][] STATE_TABLE = {
             {},                                                   // 0
@@ -37,14 +40,51 @@ public class BlockLogicConduit extends BlockLogic {
             {Side.NORTH, Side.WEST},   {Side.NORTH, Side.EAST},   // 12-13
             {Side.SOUTH, Side.WEST},   {Side.SOUTH, Side.EAST}    // 14-15
     };
-
     private static final int PROPAGATION_LENGTH = 15;
     public static final int STATE_COUNT = 16;
-
     public static final int STATE_MASK = 0b1111;
     public static final int POWER_MASK = 0b1111;
     public static final int POWER_SHIFT = 4;
 
+    private static final Side[][] CAP_SIDES = {
+            {Side.BOTTOM}, // 0
+            {Side.TOP},    // 1
+            {Side.NORTH},  // 2
+            {Side.SOUTH},  // 3
+            {Side.WEST},   // 4
+            {Side.EAST}    // 5
+    };
+    public static final int CAP_POWERED = 0b1000;
+    public static final int CAP_SIDE_MASK = 0b0111;
+    public static final int INERT_MARKER = 0b1111;
+
+    // Connection priorities (higher takes priority).
+    private static int pc = -1;
+    private static final int CONNECT_NONE = pc++;
+    private static final int CONNECT_RAIL_POWERED = pc++;
+    private static final int CONNECT_NOTEBLOCK = pc++;
+    private static final int CONNECT_SPIKES = pc++;
+    private static final int CONNECT_DISPENSER = pc++;
+    private static final int CONNECT_PISTON = pc++;
+    private static final int CONNECT_ACTIVATOR = pc++;
+    private static final int CONNECT_BUTTON = pc++;
+    private static final int CONNECT_LEVER = pc++;
+    private static final int CONNECT_TORCH = pc++;
+    private static final int CONNECT_REDSTONE_LANTERN = pc++;
+    private static final int CONNECT_REDSTONE_BLOCK = pc++;
+    private static final int CONNECT_MOTION_SENSOR = pc++;
+    private static final int CONNECT_MATCHER = pc++;
+    private static final int CONNECT_TIMER = pc++;
+    private static final int CONNECT_REPEATER = pc++;
+    private static final int CONNECT_REDSTONE_DUST = pc++;
+    private static final int CONNECT_CONDUIT = pc++;
+
+    // Shape categories for matcher equivalence
+    private static final int SHAPE_CLOSED = 0;
+    private static final int SHAPE_CAPPED = 1;
+    private static final int SHAPE_STRAIGHT = 2;
+    private static final int SHAPE_CORNER = 3;
+
     public BlockLogicConduit(@NotNull Block<?> block, @NotNull Material material) {
         super(block, material);
     }
@@ -62,16 +102,10 @@ public class BlockLogicConduit extends BlockLogic {
 
     @Override
     public void animationTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand) {
-        int data = world.getBlockData(tilePos);
+        int power = getPower(world, tilePos);
 
-        if (data == 15 << POWER_SHIFT) {
-            return;
-        }
-
-        int strength = (data >> POWER_SHIFT) & POWER_MASK;
-
-        if (strength > 0) {
-            world.playBlockEvent(tilePos, LevelListener.EVENT_CONDUIT_SURFACE_PARTICLES, packEventConduitData(Side.NONE, strength));
+        if (power > 0) {
+            world.playBlockEvent(tilePos, LevelListener.EVENT_CONDUIT_SURFACE_PARTICLES, packEventConduitData(null, power));
         }
     }
 
@@ -87,7 +121,7 @@ public class BlockLogicConduit extends BlockLogic {
 
     @Override
     public boolean suffocatesEntities(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Class<? extends Entity> entityClass) {
-                return true;
+        return true;
     }
 
     @Override
@@ -96,14 +130,14 @@ public class BlockLogicConduit extends BlockLogic {
     @Override
     public void onNeighborChanged(final @NotNull World world, final @NotNull TilePosc cTilePos, final @NotNull Block<?> block) {
         if (world.isClientSide) return;
-        world.getConduitHandler().onConduitUpdated(cTilePos);
+        world.getWireHandler().onWireUpdated(cTilePos);
     }
 
     @Override
     public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
         super.onPlacedByWorld(world, tilePos);
         if (!world.isClientSide) {
-            world.getConduitHandler().onConduitAdded(tilePos);
+            world.getWireHandler().onWireAdded(tilePos);
         }
     }
 
@@ -111,37 +145,13 @@ public class BlockLogicConduit extends BlockLogic {
     public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
         super.onRemoved(world, tilePos, data);
         if (!world.isClientSide) {
-            world.getConduitHandler().onConduitRemoved(tilePos, data);
+            world.getWireHandler().onWireRemoved(tilePos, new BlockState(this.block, data));
         }
     }
 
     // TODO: onMoved and onFlung
 
-    /**
-     * Defines the placement and routing behavior of the conduit when placed into the world by an entity.
-     * <p>
-     * This method handles three distinct placement modes:
-     * <ul>
-     * <li><b>Rotation Lock:</b> Absolute override. Forces the conduit to place as a straight pipe aligned
-     * with the player's active rotation lock direction.</li>
-     * <li><b>Sneaking (Manual Placement):</b> Bypasses auto-connection. If placed against a closed conduit port,
-     * it will force that port open and connect to it. Otherwise, defaults to routing a connection from the
-     * clicked block face toward the placing entity.</li>
-     * <li><b>Standard (Auto-connection):</b> Scans adjacent blocks for valid, open conduit ports to link up with.</li>
-     * </ul>
-     * <li><i>1 Valid Neighbor:</i> Routes from the neighbor toward the entity.</li>
-     * <li><i>2 Valid Neighbors:</i> Creates a straight or corner connection linking both neighbors.</li>
-     * <li><i>3+ Valid Neighbors:</i> Defaults to routing from the block placed against toward the entity.</li>
-     * </ul>
-     * </li>
-     * </ul>
-     * @param world          World the block is being placed in.
-     * @param cTilePos       The position where this new conduit is being placed.
-     * @param sidePlacedOnto The face of the existing block that the entity clicked against to place this block.
-     * @param mob            The mob placing the block.
-     * @param xHit           The X coordinate of the cursor hit on the block face.
-     * @param yHit           The Y coordinate of the cursor hit on the block face.
-     */
+    // Javadocs were out of date for placement and interaction and I can't be bothered to rewrite them
     @Override
     public void onPlacedByMob(final @NotNull World world, final @NotNull TilePosc cTilePos, final @NotNull Side sidePlacedOnto, final @NotNull Mob mob, final double xHit, final double yHit) {
         Side sideFacingPlayer = Direction.getLockable(mob).opposite().side();
@@ -149,84 +159,50 @@ public class BlockLogicConduit extends BlockLogic {
 
         int stateToPlaceAs = 0;
 
-        if (mob instanceof Player player) {
-            if (player.rotationLock != null) {
-                Side lockSide = player.rotationLock.side();
-                stateToPlaceAs = getStateFromTwoSides(lockSide, lockSide.opposite());
-            }
-        }
-
-        if (stateToPlaceAs == 0 && mob.isSneaking()) {
-            boolean openedClosedFace = false;
+        if (mob.isSneaking()) {
             TilePos clickedPos = new TilePos(cTilePos.x() + sideClickedAgainst.offsetX(), cTilePos.y() + sideClickedAgainst.offsetY(), cTilePos.z() + sideClickedAgainst.offsetZ());
 
             if (world.getBlockType(clickedPos) == this.block) {
                 int clickedData = world.getBlockData(clickedPos);
 
-                if (!isSideOpen(clickedData, sidePlacedOnto)) {
-                    int clickedState = clickedData & STATE_MASK;
-                    int clickedStrength = (clickedData >> POWER_SHIFT) & POWER_MASK;
-                    int newClickedState = getNextState(clickedState, sidePlacedOnto);
+                if (!isInert(clickedData) && !isSideOpen(clickedData, sidePlacedOnto)) {
+                    int newClickedData = getNextDataForFace(world, clickedPos, clickedData, sidePlacedOnto);
 
-                    if (newClickedState != clickedState) {
-                        world.setBlockDataNotify(clickedPos, (clickedStrength << POWER_SHIFT) | newClickedState);
+                    if (newClickedData != clickedData) {
+                        world.setBlockDataNotify(clickedPos, newClickedData);
                         this.onNeighborChanged(world, clickedPos, this.block);
-                        openedClosedFace = true;
                     }
 
                 }
             }
 
-            if (openedClosedFace) {
-                stateToPlaceAs = getStateFromTwoSides(sideClickedAgainst, sideClickedAgainst.opposite());
-            } else {
-                if (sideClickedAgainst != sideFacingPlayer && sideFacingPlayer != Side.NONE) {
-                    stateToPlaceAs = getStateFromTwoSides(sideClickedAgainst, sideFacingPlayer);
-                } else {
-                    stateToPlaceAs = getStateFromTwoSides(sideClickedAgainst, sideClickedAgainst.opposite());
-                }
-            }
+            stateToPlaceAs = connectTowardPlayer(sideClickedAgainst, sideFacingPlayer);
         }
-        else if (stateToPlaceAs == 0) {
-            List<Side> validSides = new ArrayList<>();
-
-            for (Side side : Side.values()) {
-                TilePos nTilePos = new TilePos(cTilePos.x() + side.offsetX(), cTilePos.y() + side.offsetY(), cTilePos.z() + side.offsetZ());
-
-                if (world.getBlockType(nTilePos) == this.block) {
-                    int nData = world.getBlockData(nTilePos);
-
-                    if (isSideOpen(nData, side.opposite())) {
-                        validSides.add(side);
-                    }
+        else {
+            final int[] priorities = new int[Side.sides.length];
+            List<Side> validNeighbors = new ArrayList<>();
+
+            for (Side side : Side.sides) {
+                int priority = connectionPriority(world, cTilePos, side);
+                priorities[side.id] = priority;
+                if (priority > CONNECT_NONE) {
+                    validNeighbors.add(side);
                 }
             }
 
-            int numOfValidSides = validSides.size();
-
-            if (numOfValidSides == 1) {
-                Side autoConnectedSide = validSides.get(0);
-
-                if (sideFacingPlayer != autoConnectedSide && sideFacingPlayer != Side.NONE) {
-                    stateToPlaceAs = getStateFromTwoSides(autoConnectedSide, sideFacingPlayer);
-                } else {
-                    stateToPlaceAs = getStateFromTwoSides(autoConnectedSide, autoConnectedSide.opposite());
-                }
-            } else if (numOfValidSides == 2) {
-                stateToPlaceAs = getStateFromTwoSides(validSides.get(0), validSides.get(1));
-            } else if (numOfValidSides > 2) {
-                TilePos nTilePos = new TilePos(cTilePos).add(sideClickedAgainst);
-
-                boolean isMatchingNeighbor = world.getBlockType(nTilePos) == this.block;
-                boolean isNeighborSideOpen = isSideOpen(world.getBlockData(nTilePos), sidePlacedOnto);
-
-                if (isMatchingNeighbor && isNeighborSideOpen) {
-                    if (sideFacingPlayer != sideClickedAgainst && sideFacingPlayer != Side.NONE) {
-                        stateToPlaceAs = getStateFromTwoSides(sideClickedAgainst, sideFacingPlayer);
-                    } else {
-                        stateToPlaceAs = getStateFromTwoSides(sideClickedAgainst, sideClickedAgainst.opposite());
+            if (validNeighbors.size() == 1) {
+                stateToPlaceAs = connectTowardPlayer(validNeighbors.get(0), sideFacingPlayer);
+            } else if (validNeighbors.size() >= 2) {
+                validNeighbors.sort((side1, side2) -> {
+                    if (priorities[side1.id] != priorities[side2.id]) {
+                        return Integer.compare(priorities[side2.id], priorities[side1.id]);
                     }
-                }
+                    int rank1 = tiebreakRank(side1, sideClickedAgainst, sideFacingPlayer);
+                    int rank2 = tiebreakRank(side2, sideClickedAgainst, sideFacingPlayer);
+                    if (rank1 != rank2) return Integer.compare(rank1, rank2);
+                    return Integer.compare(side1.id, side2.id);
+                });
+                stateToPlaceAs = getStateFromTwoSides(validNeighbors.get(0), validNeighbors.get(1));
             }
         }
 
@@ -237,30 +213,6 @@ public class BlockLogicConduit extends BlockLogic {
     }
 
 
-    /**
-     * Handles right-click interactions with an existing conduit in the world.
-     * <p>
-     * This method controls the manual toggling of conduit connection ports. The interaction succeeds
-     * and toggles the port state under the following conditions:
-     * <ul>
-     * <li>The player is holding nothing (empty hand).</li>
-     * <li>The player is holding another conduit, but clicks on a <b>closed</b> port.</li>
-     * </ul>
-     * <p>
-     * If the player is holding a different block/item, or holding a conduit and clicks an <b>open</b> port,
-     * this method yields the interaction to allow standard block placement or item usage.
-     * <p>
-     * Successful interactions will update the block state, trigger neighbor updates, play activation
-     * sound effects, and spawn visual port particles.
-     * @param world    The world containing the block.
-     * @param cTilePos The position of the conduit being interacted with.
-     * @param player   The player interacting with the block.
-     * @param side     The specific face of the conduit that was clicked (can be null if interacted via indirect means).
-     * @param xHit     The precise X coordinate of the cursor hit on the block face.
-     * @param yHit     The precise Y coordinate of the cursor hit on the block face.
-     * @return {@code true} if the interaction was consumed (port toggled); {@code false} if the interaction
-     * should pass through to default item/block placement logic.
-     */
     @Override
     public boolean onInteracted(final @NotNull World world, final @NotNull TilePosc cTilePos, final @NotNull Player player, final @Nullable Side side, final double xHit, final double yHit) {
         if(side == null) return false;
@@ -274,52 +226,63 @@ public class BlockLogicConduit extends BlockLogic {
 
         int cData = world.getBlockData(cTilePos);
         int cState = cData & STATE_MASK;
-        int cStrength = (cData >> POWER_SHIFT) & POWER_MASK;
 
-        if (holdingNothing && player.isSneaking() && cState == 0) {
-            if (cStrength == 0) {
-                world.setBlockDataNotify(cTilePos, (15 << POWER_SHIFT));
+        if (holdingNothing && player.isSneaking() && cState == 0 && !isCap(cData)) {
+            int inertValue = getUpperNibble(cData);
+            if (inertValue == 0) {
+                world.setBlockDataNotify(cTilePos, (INERT_MARKER << POWER_SHIFT));
                 world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, cTilePos.x(), cTilePos.y(), cTilePos.z(), "random.fizz", 0.5f, 2.6f + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8f);
                 world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, cTilePos.x(), cTilePos.y(), cTilePos.z(), "tile.activator.use", 1, 1.2f);
                 world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, cTilePos.x(), cTilePos.y(), cTilePos.z(), "note.hat", 0.7f, 0.4f);
-            } else if (cStrength == 15) {
+                return true;
+            } else if (inertValue == INERT_MARKER) {
                 world.setBlockDataNotify(cTilePos, 0);
                 world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, cTilePos.x(), cTilePos.y(), cTilePos.z(), "tile.activator.use", 1, 1.2f);
                 world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, cTilePos.x(), cTilePos.y(), cTilePos.z(), "note.hat", 0.7f, 0.4f);
+                return true;
             }
-            return true;
         }
 
-        if (holdingConduit && isSideOpen(cData, side)) {
+        if (isInert(cData)) {
             return false;
         }
 
-        int nextState = getNextState(cState, side);
+        Side[] openSides = getOpenSides(cData);
+        boolean clickedSideOpen = isSideOpen(cData, side);
 
-        if (nextState != cState) {
-            int newStrength = cStrength;
+        if (holdingConduit && clickedSideOpen && world.isAirBlock(new TilePos(cTilePos).add(side))) {
+            return false;
+        }
 
-            if (nextState == 0 || (cState == 0 && cStrength == 15)) {
-                newStrength = 0;
+        int nextData;
+        if (clickedSideOpen) {
+            if (openSides.length <= 1) {
+                nextData = 0;
+            } else {
+                Side newSide = (openSides[0] == side) ? openSides[1] : openSides[0];
+                nextData = makeCap(newSide, false);
             }
+        } else {
+            nextData = getNextDataForFace(world, cTilePos, cData, side);
+        }
 
-            world.setBlockDataNotify(cTilePos, (newStrength << POWER_SHIFT) | nextState);
-            onNeighborChanged(world, cTilePos, this.block);
+        if (nextData == cData) {
+            return false;
+        }
 
-            world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, cTilePos.x(), cTilePos.y(), cTilePos.z(), "tile.activator.use", 1, 1.2f);
-            world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, cTilePos.x(), cTilePos.y(), cTilePos.z(), "note.hat", 0.7f, 0.4f);
-            world.playBlockEvent(cTilePos, LevelListener.EVENT_CONDUIT_PORT_PARTICLES, packEventConduitData(side, newStrength));
+        world.setBlockDataNotify(cTilePos, nextData);
+        onNeighborChanged(world, cTilePos, this.block);
 
-            return true;
-        }
+        world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, cTilePos.x(), cTilePos.y(), cTilePos.z(), "tile.activator.use", 1, 1.2f);
+        world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, cTilePos.x(), cTilePos.y(), cTilePos.z(), "note.hat", 0.7f, 0.4f);
+        world.playBlockEvent(cTilePos, LevelListener.EVENT_CONDUIT_PORT_PARTICLES, packEventConduitData(side, getPower(nextData)));
 
-        return false;
+        return true;
     }
 
-    public static byte packEventConduitData(Side side, int strength) {
-        if (side == null) side = Side.NONE;
+    public static byte packEventConduitData(@Nullable Side side, int strength) {
         int s = Math.max(0, Math.min(PROPAGATION_LENGTH, strength));
-        int sideId = side.id & 0x07;
+        int sideId = (side == null) ? 0 : (side.id & 0x07);
         return (byte) ((sideId << POWER_SHIFT) | (s & POWER_MASK));
     }
 
@@ -335,9 +298,9 @@ public class BlockLogicConduit extends BlockLogic {
 
     private static boolean isEmitting(@NotNull WorldSource world, @NotNull TilePosc tilePos, @NotNull Side side) {
         final int data = world.getBlockData(tilePos);
-        if ((data & STATE_MASK) == 0) return false;
+        if (getOpenSides(data).length == 0) return false;
 
-        final int currentPower = (data >>> POWER_SHIFT) & POWER_MASK;
+        final int currentPower = getPower(data);
         if (currentPower == 0) return false;
 
         final Side sideAgainst = side.opposite();
@@ -349,22 +312,45 @@ public class BlockLogicConduit extends BlockLogic {
         return isSideOpen(data, sideAgainst);
     }
 
-    private int getNextState(int currentState, @NotNull Side sideQueried) {
-        if (currentState == 0) {
-            return getStateFromTwoSides(sideQueried, sideQueried.opposite());
-        }
 
-        Side[] currentSides = STATE_TABLE[currentState];
-        for (Side side : currentSides) {
-            if (side == sideQueried) {
-                return 0;
+    public static int getNextDataForFace(@NotNull World world, @NotNull TilePosc cTilePos, int cData, @NotNull Side side) {
+        int nextData = getNextData(cData, side);
+
+        Side[] openSides = getOpenSides(cData);
+        if (nextData == cData && (cData & STATE_MASK) != 0 && openSides.length == 2) {
+            int priority1 = connectionPriority(world, cTilePos, openSides[0]);
+            int priority2 = connectionPriority(world, cTilePos, openSides[1]);
+
+            if (priority1 != priority2) {
+                Side keptSide = (priority2 > priority1) ? openSides[1] : openSides[0];
+                nextData = getStateFromTwoSides(keptSide, side);
+            } else {
+                boolean air1 = world.isAirBlock(new TilePos(cTilePos).add(openSides[0]));
+                boolean air2 = world.isAirBlock(new TilePos(cTilePos).add(openSides[1]));
+                if (air1 != air2) {
+                    Side keptSide = air1 ? openSides[1] : openSides[0];
+                    nextData = getStateFromTwoSides(keptSide, side);
+                }
             }
         }
+        return nextData;
+    }
 
-        return currentState;
+    public static int getNextData(int data, @NotNull Side side) {
+        Side[] openSides = getOpenSides(data);
+        for (Side s : openSides) {
+            if (s == side) return data;
+        }
+        if (openSides.length == 0) {
+            return makeCap(side, false);
+        }
+        if (openSides.length == 1) {
+            return getStateFromTwoSides(openSides[0], side);
+        }
+        return data;
     }
 
-    private int getStateFromTwoSides(@NotNull Side s1, @NotNull Side s2) {
+    private static int getStateFromTwoSides(@NotNull Side s1, @NotNull Side s2) {
         if (s1 == s2) return 0;
 
         for (int i = 1; i < STATE_TABLE.length; i++) {
@@ -380,8 +366,6 @@ public class BlockLogicConduit extends BlockLogic {
         return 0;
     }
 
-
-
     /**
      * Determines the incoming signal strength from a neighboring block on any given side of the conduit and converts it. <div></div>
      * n = neighbor (ex. nTilePos = neighboring blocks TilePos) <div></div>
@@ -396,18 +380,18 @@ public class BlockLogicConduit extends BlockLogic {
         TilePos nTilePos = new TilePos(cTilePos.x() + side.offsetX(), cTilePos.y() + side.offsetY(), cTilePos.z() + side.offsetZ());
         Block<?> nBlockType = world.getBlockType(nTilePos);
 
-        int cStrength = (world.getBlockData(cTilePos) >> POWER_SHIFT) & POWER_MASK;
+        int cStrength = getPower(world.getBlockData(cTilePos));
 
         if(nBlockType == Blocks.WIRE_REDSTONE) {
             int nData = world.getBlockData(nTilePos);
             int nStrength = nData & BlockLogicWireRedstone.MASK_POWER;
-            return Math.max(0, signalConverter(nStrength, false) - 1);
+            return Math.max(0, signalConverter(nStrength) - 1);
         }
 
         if (nBlockType == Blocks.CONDUIT) {
             int nData = world.getBlockData(nTilePos);
             if (isSideOpen(nData, side.opposite())) {
-                int nStrength = (nData >> POWER_SHIFT) & POWER_MASK;
+                int nStrength = getPower(nData);
 
                 if (nStrength <= cStrength) return 0;
 
@@ -431,6 +415,18 @@ public class BlockLogicConduit extends BlockLogic {
                     }
                 }
             } else {
+                if (nBlockType == Blocks.PUMPKIN_REDSTONE) {
+                    Side pumpkinFace = Side.fromId(world1.getBlockData(nTilePos));
+                    for (Side s : Side.sides) {
+                        if (s == pumpkinFace) continue;
+                        TilePos queryPos = new TilePos(nTilePos.x() + s.offsetX(), nTilePos.y() + s.offsetY(), nTilePos.z() + s.offsetZ());
+                        Block<?> queryBlock = world1.getBlockType(queryPos);
+                        if (queryBlock != Blocks.WIRE_REDSTONE && queryBlock != Blocks.CONDUIT
+                                && queryBlock.isEmittingDirectSignal(world1, queryPos, s)) {
+                            return PROPAGATION_LENGTH;
+                        }
+                    }
+                }
                 if (nBlockType.isEmittingSignal(world1, nTilePos, side)) {
                     return PROPAGATION_LENGTH;
                 }
@@ -443,17 +439,6 @@ public class BlockLogicConduit extends BlockLogic {
         return 0;
     }
 
-    /**
-     * Determines a conduit power level output toward a given side, or 0 if that side is closed. <div></div>
-     *      c = conduit (ex. cStrength = this conduit Signal Strength) <div></div>
-     * @param cData The metadata of the conduit.
-     * @param sideTowardReceiver The side of the conduit facing the block asking for power.
-     * @return Conduit power (0-{@link #PROPAGATION_LENGTH})
-     */
-    public static int getOutputPower(int cData, @NotNull Side sideTowardReceiver) {
-        return isSideOpen(cData, sideTowardReceiver) ? (cData >> POWER_SHIFT) & POWER_MASK : 0;
-    }
-
     /**
      * Determines if a specific side on a conduit is open. <div></div>
      *      c = conduit (ex. cStrength = this conduit Signal Strength) <div></div>
@@ -462,15 +447,7 @@ public class BlockLogicConduit extends BlockLogic {
      * @return true if the side is open, false otherwise.
      */
     public static boolean isSideOpen(int cData, @NotNull Side side) {
-        int cState = cData & STATE_MASK;
-
-        if (cState == 0) {
-            return false;
-        }
-
-        Side[] openSides = STATE_TABLE[cState];
-
-        for (Side s : openSides) {
+        for (Side s : getOpenSides(cData)) {
             if (s == side) {
                 return true;
             }
